;//**   File: gstdin.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, stdcall
option casemap: none

include windows.inc
include kernel32.inc


.code

;===================================
;   int stdcall gStdIn (char* pc)  
;===================================
gStdIn proc pc:dword
	;/-----------------------------------------------------------------------\
	;| Gets a string from console until return's pressed                     |
	;| The pc must have size: (chars typed in console) + (return) + (1 byte) |
	;| Returns the bytes read                                                |
	;\-----------------------------------------------------------------------/
	local bytesRead:dword
	push ebx
	
	invoke GetStdHandle, STD_INPUT_HANDLE
	mov ebx, eax
	
	invoke ReadFile, ebx, pc, 256, addr bytesRead, NULL
	mov eax, bytesRead
	
	;--------------
	;finalize sting
	;--------------
	mov ebx, dword ptr [pc]
	lea ebx, [ebx+eax-2]
	mov word ptr [ebx], 00h          ;word because the ReadFile stops when return's pressed but it adds 0Dh plus 0Ah to the string
		
	pop ebx
	ret
gStdIn endp

end