;//**   File: gstrtointhex.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat
option casemap: none

		
.code

;==========================================
;   int stdcall gStrToIntHex (char* str)
;==========================================
gStrToIntHex equ _gStrToIntHex@4
gStrToIntHex proc
	;/------------------------------------------------------------------------\
	;| Convert a string that represents a Hexademical number to an int.       |
	;| Example gIntToStrHex("123FaD") returns the int 0x123FAD.               |
	;| If the func finds a wrong char int the given sting then it returns -1. |
	;\------------------------------------------------------------------------/
	push ebx                      ;the num
	push esi                      ;points to str
	
	cld
	
	mov esi, dword ptr [esp+0Ch]
	xor ebx, ebx
	lodsb
	
	@@:
	.if al>='0' && al<='9'
		shl ebx, 04h
		sub al, '0'
		or bl, al
	.elseif al>='A' && al<='F'
		shl ebx, 04h
		sub al, ('A' - 0Ah)
		or bl, al
	.elseif al>='a' && al<='f'
		shl ebx, 04h
		sub al, ('a' - 0Ah)
		or bl, al
	.else                         ;error
		or eax, 0FFFFFFFFh          ;return -1
		jmp @F
	.endif
	
	lodsb
	test al, al
	jne @B
	
	mov eax, ebx
	
	@@:
	pop esi
	pop ebx
	ret 04h
gStrToIntHex endp
	
	
end